/*
(C) 2007,2010 Katsutoshi YAGISHITA (yagisita@spnet.ne.jp)
*/

var accountinfo_url_param = "?_ControlID=WPLETacR011Control&_PageID=DefaultPID&_ActionID=DefaultAID&getFlg=on";
var portforio_url_param = "?sep_ind_specify_kbn=0&sort_kbn=&sort_id=&pts_kbn=0&_ControlID=WPLETpfR001Control&_PageID=WPLETpfR001Rlst10&_DataStoreID=DSWPLETpfR001Control&_ActionID=reloadPfList&getFlg=on";

function parseAccountinfo(target, body)
{
	target.accountinfo_total = null;

	var e;
	if ((e = getSubstringByDivNodeFromHtml(body, "\x3c!--ۗLY]--\x3e", "\x3c!--ۗLY]--\x3e")) != null) {
		var divs = e.getElementsByTagName("DIV");
		if (divs) {
			var i;
			for (i = 0; i < divs.length; ++i) {
				if (getSpecifiedChildOfElement(divs[i]) == "v") {
					var ptd;
					if ((ptd = getSpecifiedParentOfElement(divs[i], "TD")) != null) {
						for (ptd = ptd.nextSibling; ptd; ptd = ptd.nextSibling) {
							if (ptd.nodeName == "TD") {
								if (ptd.firstChild && ptd.firstChild.firstChild && ptd.firstChild.firstChild.firstChild)
									target.accountinfo_total = ptd.firstChild.firstChild.firstChild.nodeValue;
								break;
							}
						}
					}
					break;
				}
			}
		}
	}
	if (target.accountinfo_total == null)
		return false;

	if (target.finishFunc)
		target.finishFunc(target, target, 0);

	return true;
}

function parsePortforio(target, body)
{
	target.data = null;

	var e = getSubstringByDivNodeFromHtml(body, "\x3c!--ו--\x3e", "\x3c!--ו--\x3e");
	if (e == null)
		return false;

	var portforioTable = null;

	var index_name = -1;
	var index_currentrate = -1;
	var index_diffbyyesterday = -1;
	var index_diffbyyesterday_percent = -1;
	var index_highestrate_today = -1;
	var index_lowestrate_today = -1;
	var index_buyrate = -1;
	var index_sellrate = -1;
	var index_amount = -1;
	var index_cost = -1;
	var index_profit = -1;
	var index_profit_percent = -1;

	var tds;
	for (tds = e.getElementsByTagName("TD"), i = 0; portforioTable == null && i < tds.length; ++i) {
		if (getSpecifiedChildOfElement(tds[i]) == "iR[hj") {
			var trhead = getSpecifiedParentOfElement(tds[i], "TR");
			if (trhead) {
				tds = trhead.getElementsByTagName("TD");
				var j;
				for (j = 0; tds && j < tds.length; ++j) {
					var tdstr = getSpecifiedChildOfElement(tds[j]);
					if (tdstr == "iR[hj")
						index_name = j;
					else if (tdstr == "ݒl")
						index_currentrate = j;
					else if (tdstr == "O")
						index_diffbyyesterday = j;
					else if (tdstr == "Oij")
						index_diffbyyesterday_percent = j;
					else if (tdstr == "l")
						index_highestrate_today = j;
					else if (tdstr == "l")
						index_lowestrate_today = j;
					else if (tdstr == "Czl")
						index_buyrate = j;
					else if (tdstr == "Czl")
						index_sellrate = j;
					else if (tdstr == "擾P" || tdstr == "QlP")
						index_cost = j;
					else if (tdstr == "")
						index_amount = j;
					else if (tdstr == "v")
						index_profit = j;
					else if (tdstr == "vij")
						index_profit_percent = j;
					else if (tdstr == "O/") {
						var atag = getSpecifiedChildOfElement(tds[j], "A");
						if (atag && atag.innerHTML) {
							if (atag.innerHTML.indexOf("lij") >= 0)
								index_diffbyyesterday_percent = j;
							else if (atag.innerHTML.indexOf("l") >= 0)
								index_diffbyyesterday = j;
						}
					}
				}
				if ((portforioTable = getSpecifiedParentOfElement(trhead, new Array("TBODY", "TABLE"))) != null)
				break;
			}
		}
	}
	if (portforioTable == null || index_name < 0) {
		if (body.indexOf("̃|[gtHIɖǉɂ́u̒ǉo^vĉB") >= 0)
			return true;
		return false;
	}

	var trs = portforioTable.getElementsByTagName("TR");
	if (!trs)
		return false;

	var i;
	for (i = 1; i < trs.length; ++i) {
		tds = trs[i].getElementsByTagName("TD");
		if (tds.length > index_name) {
			var o = createEtradeStockObjectFromLink(getSpecifiedChildOfElement(tds[index_name], "A"));
			if (!o)
				continue;

			if (index_currentrate >= 0 && tds.length >= index_currentrate)
				o.currentrate = getSpecifiedChildOfElement(tds[index_currentrate]);
			if (index_diffbyyesterday >= 0 && tds.length >= index_diffbyyesterday)
				o.diffbyyesterday = getSpecifiedChildOfElement(tds[index_diffbyyesterday]);
			if (index_diffbyyesterday_percent >= 0 && tds.length >= index_diffbyyesterday_percent)
				o.diffbyyesterday_percent = getSpecifiedChildOfElement(tds[index_diffbyyesterday_percent]);
			if (index_highestrate_today >= 0 && tds.length >= index_highestrate_today)
				o.highestrate_today = getSpecifiedChildOfElement(tds[index_highestrate_today]);
			if (index_lowestrate_today >= 0 && tds.length >= index_lowestrate_today)
				o.lowestrate_today = getSpecifiedChildOfElement(tds[index_lowestrate_today]);
			if (index_buyrate >= 0 && tds.length >= index_buyrate)
				o.buyrate = getSpecifiedChildOfElement(tds[index_buyrate]);
			if (index_sellrate >= 0 && tds.length >= index_sellrate)
				o.sellrate = getSpecifiedChildOfElement(tds[index_sellrate]);
			if (index_amount >= 0 && tds.length >= index_amount)
				o.amount = getSpecifiedChildOfElement(tds[index_amount]);
			if (index_cost >= 0 && tds.length >= index_cost)
				o.cost = getSpecifiedChildOfElement(tds[index_cost]);
			if (index_profit >= 0 && tds.length >= index_profit)
				o.profit = getSpecifiedChildOfElement(tds[index_profit]);
			if (index_profit_percent >= 0 && tds.length >= index_profit_percent)
				o.profit_percent = getSpecifiedChildOfElement(tds[index_profit_percent]);

			target.data = mergeEtrdObject(target.data, o, null);
		}
	}

	if (target.finishFunc)
		target.finishFunc(target, target, 0);

	return true;
}


function getAccount(target, callback)
{
	if (!target || (!target.baseurl || !target.jsessionid))
		return false;

	target.accountinfo_total = null;

	target.finishFunc = callback;

	var accountinfo_url = target.baseurl + accountinfo_url_param;

	getAndParseHtml(function (body) { parseEtradeHtml(parseAccountinfo, target, body); }, accountinfo_url, "GET", null, createHeaderArrayForSession(target.jsessionid + '; ' + target.trading_site));

	return true;
}

function getPortforio(target, callback)
{
	if (!target || (!target.baseurl || !target.jsessionid))
		return false;

	target.data = null;

	target.finishFunc = callback;

	var portforio_url = target.baseurl + portforio_url_param + "&indicate_id=" + "000000000000001" + "&portforio_id=" + "000000000000001";

	getAndParseHtml(function (body) { parseEtradeHtml(parsePortforio, target, body); }, portforio_url, "GET", null, createHeaderArrayForSession(target.jsessionid + '; ' + target.trading_site));

	return true;
}
