/*
(C) 2010 Katsutoshi YAGISHITA (yagisita@spnet.ne.jp)
*/

function parseFutureAccountinfo(target, body)
{
	target.future.accountinfo_total = null;
	target.future.yoryoku = null;
	target.future.ukeire = null;
	target.future.hitsuyou = null;
	target.future.kousoku = null;
	target.future.sonneki = null;
	target.future.toujitsusonneki = null;
	target.future.data = null;

	var e;
	if ((e = getSubstringByDivNodeFromHtml(body, "<!--title-->", "<!--//-->")) != null) {
		var tds;
		tds = e.getElementsByTagName("TD");
		if (tds) {
			var i;
			for (i = 0; i < tds.length; ++i) {
				var s = getValuableStringOfElement(tds[i]);
				if (s) {
					var ptd = null;
					for (ptd = tds[i].nextSibling; ptd; ptd = ptd.nextSibling) {
						if (ptd.nodeName == "TD")
							break;
					}
					if (ptd) {
						var v = getValueFromYenString(getSpecifiedChildOfElement(ptd))
						if (s.indexOf("i`j") >= 0)
							target.future.yoryoku = v;
						else if (s.indexOf("iBj") >= 0)
							target.future.ukeire = v;
						else if (s.indexOf("iCj") >= 0)
							target.future.hitsuyou = v;
						else if (s.indexOf("iDj") >= 0)
							target.future.kousoku = v;
					}
				}
			}
		}
	}

	var i1, i2;
	if ((i1 = body.indexOf("vv")) >= 0 && (i2 = body.indexOf("~", i1)) >= 0) {
		target.future.sonneki = getValueFromYenString(body.substring(i1 + 4, i2));
	}
	if ((i1 = body.indexOf("Zzv")) >= 0 && (i2 = body.indexOf("~", i1)) >= 0) {
		target.future.toujitsusonneki = getValueFromYenString(body.substring(i1 + 4, i2));
	}

	if (target.future.ukeire != null && target.future.kousoku != null && target.future.toujitsusonneki != null) {
		var toujitsu = parseCommaNumberString(target.future.toujitsusonneki);
		target.future.accountinfo_total = formatCommaNumberString(parseCommaNumberString(target.future.ukeire) - parseCommaNumberString(target.future.kousoku) + ((toujitsu > 0) ? toujitsu : 0));
	}

	if (target.future.accountinfo_total == null)
		return false;

	var a = new Array();
	if ((e = getSubstringByDivNodeFromHtml(body, "<!--ʈꗗ-->", "<!--//ʈꗗ-->")) != null) {
		var divs;
		divs = e.getElementsByTagName("TD");
		if (divs) {
			var i;
			for (i = 0; i < divs.length; ++i) {
				if (getSpecifiedChildOfElement(divs[i]) == "") {
					var j = -1;
					var ptr;
					for (ptr = getSpecifiedParentOfElement(divs[i], "TR"); ptr; ptr = ptr.nextSibling) {
						if (ptr.nodeName == "TR" && j++ >= 0) {
							var ptds = ptr.getElementsByTagName("TD");

							var o = new Object();
							o.name = getSpecifiedChildOfElement(ptds[0]);
							o.direction = getSpecifiedChildOfElement(ptds[3]);
							o.initrate = getValueFromYenString(getSpecifiedChildOfElement(ptds[4]));
							o.num = getValueFromYenString(getValuableStringOfElement(ptds[5]));
							o.currate = getValueFromYenString(getSpecifiedChildOfElement(ptds[6]));
							o.profit = formatCommaNumberString(parseCommaNumberString(getValueFromYenString(getSpecifiedChildOfElement(ptds[8]))), true);
							a[a.length] = o;
						}
					}
				}
			}
		}
	}

	target.future.data = a;

	if (target.finishFunc)
		target.finishFunc(target.future, target, 0);

	return true;
}

function getFutureAccount(target, callback)
{
	if (!islogined_future(target)) {
		callback(null, null, 1);
		return false;
	}

	target.finishFunc = callback;

	var futureaccountinfo_url = "https://depindex.sbisec.co.jp/cfront/servlet/cfront.ReferenceController";

	var param = "";
	param += "P_SEL=1";
	param += '&';
	param += "ORDER_PROCNO=5";
	param += '&';
	param += "STARTLINE=1";
	param += '&';
	param += "QUERYCOUNT=50";
	param += '&';
	param += "sessionID=";
	param += target.future.sessionid;

	getAndParseHtml(function (body) { parseEtradeHtml(parseFutureAccountinfo, target, body, futureaccountinfo_url); }, futureaccountinfo_url, "POST", param, createHeaderArrayForSession(target.future.jsessionid + '; ' + target.future.bigipserveretj_depindex_web_pool + '; ' + target.trading_site));

	return true;
}
