/*
(C) 2010 Katsutoshi YAGISHITA (yagisita@spnet.ne.jp)
*/

function getSubstringFromHtml(src, top, bottom, excludetop, includebottom)
{
	if (!src)
		return null;

	var i1, i2;
	if ((i1 = src.indexOf(top)) < 0)
		return null;
	if (excludetop)
		i1 = i1 + top.length;
	if ((i2 = src.indexOf(bottom, i1)) < 0)
		return null;
	if (includebottom)
		i2 = i2 + bottom.length;

	return src.substring(i1, i2);
}

function getSubstringByDivNodeFromHtml(src, top, bottom, excludetop, includebottom)
{
	var	str = getSubstringFromHtml(src, top, bottom, excludetop, includebottom);
	if (!str)
		return null;

	var e = document.createElement("DIV");
	e.innerHTML = str.replace(new RegExp("<img[^>]*>", "gi"), "");

	return e;
}

function getSpecifiedChildOfElement(element, tag)
{
	if (!element)
		return null;

	var c;
	for (c = element.firstChild; c != null; c = c.firstChild) {
		var cc;
		for (cc = c; cc != null; cc = cc.nextSibling) {
			if (tag) {
				if ((typeof tag == typeof "string")) {
					if (cc.tagName == tag)
						return cc;
				}
				else {
					var i;
					for (i = 0; i < tag.length; ++i) {
						if (cc.tagName == tag[i])
							return cc;
					}
				}
			}
			else {
				if (cc.nodeValue != null)
					return cc.nodeValue;
			}
		}
		if (c.nextSibling != null)
			break;
	}

	return null;
}

function getValuableStringOfElement(element)
{
	if (!element)
		return null;

	var c;
	for (c = element.firstChild; c != null; c = c.firstChild) {
		var cc;
		for (cc = c; cc != null; cc = cc.nextSibling) {
			if (!cc.nodeValue) {
				c = cc;
				break;
			}
			else {
				var i;
				for (i = 0; i < cc.nodeValue.length; ++i) {
					var d = cc.nodeValue.charAt(i);
					if (d != ' ' && d != '\t' && d != '\n' && d != '\r')
						return cc.nodeValue;
				}
			}
		}
	}

	return null;
}

function getSpecifiedParentOfElement(element, tag)
{
	if (!element)
		return null;

	var p;
	for (p = element.parentNode; p != null; p = p.parentNode) {
		if ((typeof tag == typeof "string")) {
			if (p.tagName == tag)
				return p;
		}
		else {
			var i;
			for (i = 0; i < tag.length; ++i) {
				if (p.tagName == tag[i])
					return p;
			}
		}
	}

	return null;
}

function getParameterFromSearchString(str, param)
{
	if (!str)
		return null;

	var i1, i2;
	if ((i1 = str.indexOf(param + "=")) < 0)
		return null;
	i1 = i1 + param.length + 1;

	if ((i2 = str.indexOf("&", i1)) >= 0)
		return str.substring(i1, i2);

	return str.substring(i1);
}

function trimString(src)
{
	if (!src)
		return null;

	var ii, jj;

	for (ii = 0; ii < src.length; ++ii) {
		if (src[ii] != " " && src[ii] != "\r" && src[ii] != "\n" && src[ii] != "\t")
			break;
	}
	for (jj = src.length - 1; jj >= 0; --jj) {
		if (src[jj] != " " && src[jj] != "\r" && src[jj] != "\n" && src[jj] != "\t")
			break;
	}

	if (jj <= ii)
		return "";

	return src.substring(ii, jj + 1);
}

function trimNumberString(src)
{
	if (!src)
		return null;

	var ii, jj;

	for (ii = 0; ii < src.length; ++ii) {
		if (src[ii] == "1" || src[ii] == "2" || src[ii] == "3" || src[ii] == "4" || src[ii] == "5" || src[ii] == "6" || src[ii] == "7" || src[ii] == "8" || src[ii] == "9")
			break;
	}
	for (jj = ii; jj < src.length; ++jj) {
		if (src[jj] != "0" && src[jj] != ',' && src[jj] != "1" && src[jj] != "2" && src[jj] != "3" && src[jj] != "4" && src[jj] != "5" && src[jj] != "6" && src[jj] != "7" && src[jj] != "8" && src[jj] != "9")
			break;
	}

	if (jj <= ii)
		return null;

	return src.substring(ii, jj);
}

function parseCommaNumberString(s)
{
	if (!s)
		return NaN;

	var ss = s.replace(new RegExp(",", "g"), "");

	return parseInt(ss);
}

function formatCommaNumberString(n, withsign)
{
	var s = "";

	if (n == 0)
		return "0";

	var nn = Math.abs(n);
	do {
		var ss = "" + (nn % 1000);
		if (Math.floor(nn / 1000) > 0) {
			while (ss.length < 3)
				ss = "0" + ss;
		}
		s = ss + ((s.length > 0) ? "," : "") + s;
	} while ((nn = Math.floor(nn / 1000)) > 0);

	if (n < 0)
		s = "-" + s;
	else if (n > 0) {
		if (withsign)
			s = "+" + s;
	}

	return s;
}

function setInnerText(e, s)
{
	if (e.innerText != undefined)
		e.innerText = s;
	else if (e.textContent != undefined)
		e.textContent = s;
}

function getInnerText(e)
{
	if (e.innerText != undefined)
		return e.innerText;
	else if (e.textContent != undefined)
		return e.textContent;

	return null;
}


function getAndParseHtml(parseFunc, url, method, body, headers)
{
	/*
	window.console.log("url = " + url);
	window.console.log("method = " + method);
	window.console.log("body = " + body);
	if (headers) {
		var i;
		for (i = 0; i < headers.length; ++i)
			window.console.log("request_headers[" + i + "] = (" + headers[i].name + ", " + headers[i].value + ")");
	}
	*/

	if (!XMLHttpRequest)
		return;

	if (navigator.userAgent.indexOf("Firefox") >= 0)
		netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");

	var reqobj = new XMLHttpRequest();
	if (!reqobj)
		return;
	reqobj.onreadystatechange = function() {
		if (reqobj.readyState == 4) {
			/*
			window.console.log("response_headers = " + reqobj.getAllResponseHeaders());
			window.console.log("response_body = " + reqobj.responseText);
			*/
			parseFunc(reqobj.responseText, url, reqobj);
		}
	};
	if (navigator.userAgent.indexOf("Firefox") >= 0)
		reqobj.overrideMimeType("text/plain; charset=Shift_JIS");

	reqobj.open((method) ? method : "GET", url);
	reqobj.setRequestHeader("If-Modified-Since", "Fri, 28 Mar 1975 12:00:00 GMT");
	if (body)
		reqobj.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	if (headers) {
		var i;
		for (i = 0; i < headers.length; ++i)
			reqobj.setRequestHeader(headers[i].name, headers[i].value);
	}
	reqobj.send((body) ? body : null);
}

function parseEtradeHtml(parseFuncImpl, target, body, url, obj)
{
	if (!parseFuncImpl(target, body, url, obj)) {
		if (target.finishFunc)
			target.finishFunc(null, null, isRequireLogin(url, body, obj) ? 1 : -1);
		return false;
	}

	return true;
}

function isRequireLogin(url, body, obj)
{
	if (url == "https://fx.sbisec.co.jp/forex/trade/client/syoukai/syoukaiKouza.aspx") {
		if (body.indexOf("ti_logout.gif") >= 0 && body.indexOf("timeout.aspx") >= 0 && body.indexOf("CTCgēxANZXĉ") >= 0)
			return true;
	}
	else if (url == "https://depindex.sbisec.co.jp/cfront/servlet/cfront.ReferenceController") {
		if (body.indexOf("CTCgēxANZXĉ") >= 0)
			return true;
	}
	else {
		if (body && body.indexOf("\x3c!--OCEJ--\x3e") >= 0)
			return true;
	}

	return false;
}

function createHeaderArrayForSession(session)
{
	if (!session || !session.length)
		return null;

	var o = new Object();
	o.name = "Cookie";
	o.value = session;

	return new Array(o);
}

function getSessionFromHeaderArray(a)
{
	if (!a || !a.length)
		return null;

	var i;
	for (i = 0; i < a.length; ++i) {
		if (a[i].name == "Cookie")
			return a[i].value;
	}

	return null;
}

function getValueFromYenString(s)
{
	var ss = "";

	var i, j;
	for (i = 0; i < s.length; ++i) {
		var c = s.charAt(i);
		if (isdigitchar(c)) {
			ss += c;
			break;
		}
	}
	for (++i; i < s.length; ++i) {
		var c = s.charAt(i);
		if (!isdigitchar(c, true))
			break;
		ss += c;
	}

	return ss;
}

function isdigitchar(c, b)
{
	var digitArray = (b) ? new Array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ',', '.') : new Array('-', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9');

	var j;
	for (j = 0; j < digitArray.length; ++j) {
		if (c == digitArray[j])
			return true;
	}
	return false;
}
